/*
This file is part of IRCaBot.
IRCaBot is IRC logger with features.
Source code: https://notabug.org/acetone/ircabot.
Copyright (C) 2023, acetone.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#pragma once

#include <inttypes.h>
#include <QString>

namespace logger {

enum Level : uint8_t
{
    Off     = 0,
    Error   = 1,
    Warning = 2,
    Info    = 3,
    Debug   = 4
};
extern Level level;

Level levelEnum(const QString& str);
QString levelString(Level level);
void customMessageOutput(QtMsgType type, const QMessageLogContext &, const QString &msg);

} // namespace
